# Get Messages

> Source: https://truto.one/docs/api-reference/unified-marketing-automation-api/messages/get/

`GET /unified/marketing-automation/messages/{id}`

Resource: **Messages** · API: **Unified Marketing Automation API**

## Supported integrations

Customer.io

## Path parameters

- **`id`** _(string, required)_
  The ID of the resource.

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.

## Response body

- **`id`** _(string, required)_
  The message's unique identifier
- **`sender`** _(object)_
  The sender of the message
  - **`id`** _(string)_
    Unique identifier of the sender
  - **`name`** _(string)_
    Name of the sender
  - **`type`** _(string)_
    Type of the sender
    Allowed: `contact`, `user`
- **`recipient`** _(object)_
  The recipient of the message
  - **`id`** _(string)_
    Unique identifier of the recipient
  - **`name`** _(string)_
    Name of the recipient
  - **`type`** _(string)_
    Type of the recipient
    Allowed: `contact`, `user`
- **`send_date`** _(string)_
  The date and time that the message was sent
- **`subject`** _(string)_
  The message's subject line
- **`body`** _(string)_
  The message's body
- **`body_html`** _(string)_
  The message's HTML body
- **`status`** _(string)_
  The sending status of the message
- **`channel`** _(string)_
  The medium through which the message was sent
  Allowed: `email`, `webhook`, `in_app`, `slack`, `push`, `twilio`
- **`campaign`** _(object)_
  The associated campaign for the message
  - **`id`** _(string)_
    Unique identifier of the campaign
- **`template`** _(object)_
  The associated template for the message
  - **`id`** _(string)_
    Unique identifier of the template
- **`updated_at`** _(string)_
  The date and time of the message's last update
- **`created_at`** _(string)_
  The date and time of the message's creation
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/marketing-automation/messages/{id}?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/marketing-automation/messages/{id}?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/marketing-automation/messages/{id}"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.get(
  'marketing-automation',
  'messages',
  '<resource_id>',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.get(
        "marketing-automation",
        "messages",
        "<resource_id>",
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
